{$G+}
program hidden; { 3D_LINE.PAS }
{ Hidden line routine - kinda buggy and schocky on most systems,
  by Bas van Gaalen }
uses u_vga,u_pal,u_3d,u_kb;

{$define deca} { deca, cube }

const
{$ifdef deca}
  fpoly=1; { first poly to draw from }
  nofpoints=12; { number of points }
  nofplanes=10; { number of planes }
  points:array[1..nofpoints,0..2] of integer=(
    (-20,-30, 20),( 20,-30, 20),( 40,  0, 40),(-40,  0, 40),
    ( 20, 30, 20),(-20, 30, 20),(-20,-30,-20),( 20,-30,-20),
    ( 40,  0,-40),(-40,  0,-40),( 20, 30,-20),(-20, 30,-20));
  planes:array[1..nofplanes,0..3] of byte=(
    (1,2,3,4),(4,3,5,6),(2,8,9,3),(3,9,11,5),(8,7,10,9),
    (9,10,12,11),(7,1,4,10),(10,4,6,12),(7,8,2,1),(6,5,11,12));
{  points:array[1..nofpoints,0..2] of integer=(
    (-20,-30, 20),( 20,-30, 20),( 40,  0, 40),(-40,  0, 40),
    ( 20, 30, 20),(-20, 30, 20),(-20,-30,-20),( 20,-30,-20),
    ( 40,  0,-40),(-40,  0,-40),( 20, 30,-20),(-20, 30,-20));
  planes:array[1..nofplanes,0..3] of byte=(
    (1,2,3,4),(4,3,5,6),(2,8,9,3),(3,9,11,5),(8,7,10,9),
    (9,10,12,11),(7,1,4,10),(10,4,6,12),(7,8,2,1),(6,5,11,12));}
{$endif}

{$ifdef cube}
  fpoly=4;
  nofpoints=8;
  nofplanes=6;
  points:array[1..nofpoints,0..2] of integer=(
    (-30,-30, 30),( 30,-30, 30),( 30, 30, 30),(-30, 30, 30),
    (-30,-30,-30),( 30,-30,-30),( 30, 30,-30),(-30, 30,-30));
  planes:array[1..nofplanes,0..3] of byte=(
    (1,2,3,4),(2,6,7,3),(6,5,8,7),(5,1,4,8),(5,6,2,1),(4,3,7,8));
{$endif}

var virscr:pointer;
var virscr2:pointer;
var virscr3:pointer;

procedure fadeout(s: word); assembler;
asm
  mov ax,s
  push ax
  pop es
  mov cx,64000
  xor ax,ax
  xor bx,bx
  xor di,di
@@fadeloop:
  mov al,es:[di]

  cmp al,2
  jb @@less

  sub al,2
  jmp @@make
@@less:
  xor al,al
@@make:
  mov es:[di],al
  inc di
  loop @@fadeloop
end;

procedure smooth2(s: word); assembler;
asm
  mov ax,s
  push ax
  pop es
  mov cx,64000-320
  xor ax,ax
  xor bx,bx
@@smthloop:
  mov al,es:[di]
  mov bl,es:[di+1]
  add ax,bx
  mov bl,es:[di-1]
  add ax,bx
  mov bl,es:[di+320]
  add ax,bx
  shr ax,2
  mov es:[di],al
  inc di
  loop @@smthloop
end;

procedure wireframe(x1,y1,x2,y2,x3,y3,x4,y4:word; c:byte);
begin
  vga_line(x1,y1,x2,y2,c);
  vga_line(x2,y2,x3,y3,c);
  vga_line(x3,y3,x4,y4,c);
  vga_line(x4,y4,x1,y1,c);
end;
const
  yo=3*8;
  color=7;
  txt:string='greetz! U get this file, and do you know from what place '+
              'this file was getz first??    this file was get from dk place'+
         '....enjoy it.     coder of this intro is dk. greetz to all. bye...   '+
         '                               ';

procedure jnzflip(const a,size:word; cmp: byte); assembler;
asm
  push ds
  mov ds,a
  push 0a000h
  pop es
  xor si,si
  xor di,di
  mov cx,size
@@loop:
  mov ah,byte ptr [ds:si]
  cmp ah,cmp
  jne @@movsb
  inc di
  inc si
  jmp @@end
@@movsb:
  movsb
@@end:
  loop @@loop
  pop ds
end;

procedure rotate_object;
const xst=1; yst=1; zst=-2;
var
  xp,yp,z:array[1..nofpoints] of integer;
  x,y,i:integer;
  n,phix,phiy,phiz:byte;
  w:word;
var txtidx,curchar,bitpos,pixline,col:byte;
begin
  phix:=0; phiy:=128; phiz:=0;
  fillchar(xp,sizeof(xp),0);
  fillchar(yp,sizeof(yp),0);
  fillchar(z,sizeof(z),0);
  destenation:=virscr;
  txtidx:=1;
  curchar:=byte(txt[txtidx]); txtidx:=1+txtidx mod length(txt);
  bitpos:=7;
  repeat
    setborder(200);
    for n:=1 to nofpoints do begin
      x:=round(points[n,0]/1.2);
      y:=round(points[n,1]/1.2);
      z[n]:=round(points[n,2]/1.2);
      rotate(x,y,z[n],phix,phiy,phiz);
      conv3dto2d(xp[n],yp[n],x,y,z[n]);
      inc(xp[n],60); inc(yp[n],133); { transfer object to middle of screen }
    end;
    for n:=1 to nofplanes do begin
      polyz[n]:=(z[planes[n,0]]+z[planes[n,1]]+z[planes[n,2]]+z[planes[n,3]]) div 4;
      pind[n]:=n;
    end;
    quicksort(nofplanes);
    for n:=1 to nofplanes do
      if not checkfront(xp[planes[pind[n],0]],yp[planes[pind[n],0]],
                    xp[planes[pind[n],1]],yp[planes[pind[n],1]],
                    xp[planes[pind[n],2]],yp[planes[pind[n],2]]) then
        wireframe(xp[planes[pind[n],0]],yp[planes[pind[n],0]],
                  xp[planes[pind[n],1]],yp[planes[pind[n],1]],
                  xp[planes[pind[n],2]],yp[planes[pind[n],2]],
                  xp[planes[pind[n],3]],yp[planes[pind[n],3]],63);
    for n:=1 to nofpoints do inc(xp[n],100);
    for n:=1 to nofplanes do
      if not checkfront(xp[planes[pind[n],0]],yp[planes[pind[n],0]],
                    xp[planes[pind[n],1]],yp[planes[pind[n],1]],
                    xp[planes[pind[n],2]],yp[planes[pind[n],2]]) then
        wireframe(xp[planes[pind[n],0]],yp[planes[pind[n],0]],
                  xp[planes[pind[n],1]],yp[planes[pind[n],1]],
                  xp[planes[pind[n],2]],yp[planes[pind[n],2]],
                  xp[planes[pind[n],3]],yp[planes[pind[n],3]],63);
    for n:=1 to nofpoints do inc(xp[n],100);
    for n:=1 to nofplanes do
      if not checkfront(xp[planes[pind[n],0]],yp[planes[pind[n],0]],
                    xp[planes[pind[n],1]],yp[planes[pind[n],1]],
                    xp[planes[pind[n],2]],yp[planes[pind[n],2]]) then
        wireframe(xp[planes[pind[n],0]],yp[planes[pind[n],0]],
                  xp[planes[pind[n],1]],yp[planes[pind[n],1]],
                  xp[planes[pind[n],2]],yp[planes[pind[n],2]],
                  xp[planes[pind[n],3]],yp[planes[pind[n],3]],63);
    inc(phix,xst); inc(phiy,yst); inc(phiz,zst);
    setborder(0);
    smooth2(seg(virscr^));
    smooth2(seg(virscr^));
    fadeout(seg(virscr^));
    flip(virscr,virscr2,320*200);
    for x:=108 to 210 do for y:=70 to 199 do begin
      w:=x+y*320;
      if mem[seg(virscr2^):w]<>0 then inc(mem[seg(virscr2^):w],63);
    end;
    for x:=218 to 319 do for y:=70 to 199 do
      if mem[seg(virscr2^):x+y*320]<>0 then inc(mem[seg(virscr2^):x+y*320],63+64);
    if bitpos=0 then begin
      curchar:=byte(txt[txtidx]); txtidx:=1+txtidx mod length(txt);
      bitpos:=8;
    end;
      for pixline:=0 to 15 do begin
        move(mem[seg(virscr3^):(yo+pixline)*320+1],mem[seg(virscr3^):(yo+pixline)*320+0],320);
        col:=
byte(((mem[seg(font^):ofs(font^)+curchar shl 4+pixline]) shr bitpos) and 1)
*(round(bitpos*pixline/(15*7)*63/2)+63+25);
        mem[seg(virscr3^):319+320*(yo+pixline)]:=col;
      end;
    dec(bitpos);
    vretrace;
    flip(virscr2,vidptr,320*200);
    jnzflip(seg(virscr3^),64000,0);
  until keypressed;
end;

var i,j:word;
begin
  getfont(font8x16);
  setvideo($13);
  {u_border:=true;}
  getmem(virscr,320*200); cls(virscr,320*200);
  getmem(virscr2,320*200); cls(virscr2,320*200);
  getmem(virscr3,320*200); cls(virscr3,320*200);
{  for i:=1 to 255 do setrgb(i,i div 16,i div 8,i div 4);}
  for i:=0 to 63 do setrgb(i,i,0,0);
  for i:=0 to 63 do setrgb(i+63,0,i,0);
  for i:=0 to 63 do setrgb(i+128,0,0,i);
  rotate_object;
  freemem(virscr,320*200);
  freemem(virscr2,320*200);
  freemem(virscr3,320*200);
  setvideo(u_lm);
end.
